<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Review Edit</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <div th:include="sidebar/sidebar_journal::sidebar_journal" th:remove="tag">
        sidebar
    </div>
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="card shadow-lg">
                    <div class="card-header">
                        <h5>Review Journal</h5>
                    </div>
                    <div class="card-body">
                        <form th:action="@{/journalDetail/edit}" method="post">
                            <div class="row mb-3">
                                <div class="col-md-12">
                                    <div class="table-responsive">
                                        <table class="table table-bordered">
                                            <tr>
                                                <td width="15%">Tanggal</td>
                                                <td width="2%">:</td>
                                                <td>
                                                    <input type="date" class="form-control" name="transactionDate" th:value="${journal.transactionDate}">
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>Di catatan oleh</td>
                                                <td>:</td>
                                                <td>
                                                    <span th:if="${journal.createdBy == null}">-</span>
                                                    <span th:if="${journal.createdBy != null}" th:text="${journal.createdBy.user}"></span>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>Deskripsi</td>
                                                <td>:</td>
                                                <td>
                                                    <input type="text" th:value="${journal.description}" name="decription" class="form-control">
                                                    <input type="hidden" th:value="${journal.id}" name="journal">
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>Institut</td>
                                                <td>:</td>
                                                <td>
                                                    <select name="institut" class="form-select" required>
                                                        <option value="">-- Pilih --</option>
                                                        <option th:each="data, row:${institut}"
                                                                th:value="${data.id}"
                                                                th:selected="${data == journal.institut}"
                                                                th:text="${data.namaInstitut}"></option>
                                                    </select>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <div class="row mb-3">
                                <div class="col-md-12 text-end">
                                    <button type="button" class="btn btn-secondary" onclick="addRow()">Tambah Baris</button>

                                </div>
                            </div>
                            <div class="row mb-3">
                                <div class="col-md-12">
                                    <div class="table-responsive">
                                        <table class="table table-bordered" id="editableTable">
                                            <thead class="table-dark">
                                            <tr>
                                                <th style="width: 50px;">#</th>
                                                <th style="width: 500px;">Akun</th>
                                                <th style="width: 150px;">Jumlah</th>
                                                <th style="width: 150px;">Tipe</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <tr th:each="data, row:${journalDetail}">
                                                <td th:text="${row.index + 1}" style="text-align: center;"></td>
                                                <td>
                                                    <select name="account" id="select-account" class="form-select select-account" style="width: 100%;">
                                                        <option value="">-- Pilih Account --</option>
                                                        <option th:each="dataAccount, row:${accountList}"
                                                                th:value="${dataAccount.id}"
                                                                th:selected="${dataAccount == data.account}"
                                                                th:text="${dataAccount.code + ' - ' + dataAccount.name}"></option>
                                                    </select>
                                                    <input type="hidden" name="journalDetails" th:value="${data.id}">
                                                </td>
                                                <td>
                                                    <input th:id="'numberInput' + ${row.index}" th:value="${#numbers.formatDecimal(data.amount, 0, 'POINT', 2, 'COMMA')}" class="form-control amount-input" type="text" name="amount">
                                                </td>
                                                <td>
                                                    <select name="balanceType" class="form-select">
                                                        <option th:each="balanceType : ${T(id.ac.tazkia.accounting.entity.BalanceType).values()}"
                                                                th:value="${balanceType}"
                                                                th:text="${balanceType}"
                                                                th:selected="${balanceType.toString() == data.balanceType.toString()}"></option>
                                                    </select>
                                                </td>
                                            </tr>
                                            </tbody>
                                            <tfoot>
                                            <tr>
                                                <td colspan="4">
                                                    <span style="color: red; font-size: 12px;">* Klik Simpan Jika Anda Perubahan Data Jurnal</span>
                                                </td>
                                            </tr>
                                            </tfoot>
                                        </table>
                                    </div>
                                    <button class="btn btn-primary" type="submit">Simpan</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <script>
        let x = document.getElementById("modeNoEdit");
        let y = document.getElementById("modeEdit");
        let z = document.getElementById("btnEdit");
        let batal = document.getElementById("batal");
        function myFunction() {

            if (x.style.display === "none") {
                x.style.display = "block";
                y.style.display = "none";
                z.style.display = "block";
            } else {
                x.style.display = "none";
                y.style.display = "block";
                z.style.display = "none";
            }
        }

        function batalEdit() {
            x.style.display = "block";
            y.style.display = "none";
            z.style.display = "block";
        }

        function cancelEdit() {
            if (x.style.display === "none") {
                x.style.display = "block";
                y.style.display = "none";
                z.style.display = "block";
            } else {
                x.style.display = "none";
                y.style.display = "block";
                z.style.display = "none";
            }
        }

        function addRow() {
            var table = document.getElementById("editableTable").getElementsByTagName('tbody')[0];
            var rowCount = table.rows.length;
            var row = table.insertRow(rowCount);

            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);
            var cell3 = row.insertCell(2);
            var cell4 = row.insertCell(3);

            cell1.innerHTML = rowCount + 1;
            cell1.style.textAlign = 'center';



            cell2.innerHTML = `
                <select name="account" class="form-select select-account" required style="width: 100%;">
                </select>
                <input type="hidden" name="journalDetails" value="">
            `;

            cell3.innerHTML = `<input id="numberInput${rowCount}" class="form-control amount-input" required type="text" name="amount">`;

            cell4.innerHTML = `
                <select name="balanceType" class="form-select" required>
                    <option value="">-- Pilih --</option>
                    <option value="DEBET">DEBET</option>
                    <option value="CREDIT">CREDIT</option>
                </select>
            `;

            // Initialize Select2 for the new select elements
            $('.select-account').select2({
                theme: 'bootstrap-5',
                placeholder: '- Select Account -',
                ajax: {
                    url: '/public/api/account/list', // URL endpoint API
                    dataType: 'json',
                    delay: 250, // Delay in milliseconds before the request is sent
                    processResults: function (response) {
                        // Proses respons dari API untuk format data Select2
                        return {
                            results: $.map(response.data, function (item) {
                                return {
                                    id: item.id,
                                    text: item.code + ' - ' + item.name
                                };
                            })
                        };
                    },
                    cache: true // Cache the results
                }
            });

            // Initialize input formatting for new amount inputs
            var newInput = document.getElementById(`numberInput${rowCount}`);
            newInput.addEventListener('input', function(e) {
                let value = e.target.value;

                // Menghapus karakter yang bukan angka atau koma
                value = value.replace(/[^\d,]/g, '');

                // Jika ada lebih dari satu koma, ambil hanya bagian sebelum koma pertama
                const parts = value.split(',');
                value = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, '.');
                if (parts.length > 1) {
                    value += ',' + parts[1];
                }

                // Mengupdate nilai input
                e.target.value = value;
            });
        }

        document.addEventListener('DOMContentLoaded', function () {
            var inputs = document.querySelectorAll('.amount-input');
            inputs.forEach(function(input) {
                input.addEventListener('input', function(e) {
                    let value = e.target.value;

                    // Menghapus karakter yang bukan angka atau koma
                    value = value.replace(/[^\d,]/g, '');

                    // Jika ada lebih dari satu koma, ambil hanya bagian sebelum koma pertama
                    const parts = value.split(',');
                    value = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, '.');
                    if (parts.length > 1) {
                        value += ',' + parts[1];
                    }

                    // Mengupdate nilai input
                    e.target.value = value;
                });
            });
        });
    </script>
</div>
</body>
</html>